@rem ============================================================================================
@rem	This batch installation file was designed by Marzo Junior.
@rem ============================================================================================

@rem ============================================================================================
@rem	Change this to your mod's name. It is not required, but it gives better feedback
@rem	to the user... Remember to leave the "@set varmodname=" part intact!
@rem ============================================================================================

@set varmodname=Redhead

@rem ============================================================================================
@rem	Change this to your mod's name. It is not required, but it gives better feedback
@rem	to the user... Remember to leave the "@set vargametitle=" part intact!
@rem ============================================================================================

@set vargametitle=Serpent Isle

@rem ============================================================================================
@rem	Displays information to user; better left alone.
@rem ============================================================================================

@echo.
@echo This batch file will install the %varmodname% mod in your computer.
@echo Make sure that you have read the readme file!
@echo.
@echo Remember that this is a mod for %vargametitle% only!
@echo.
@echo Press Ctrl+C followed by Y to abort this operation.
@echo.
@pause



@rem ============================================================================================
@rem	File prefixes. You can define your own for use with the ipk file creation below.
@rem	Basic syntax is:
@rem
@rem		@set {VGAFileName}Prefix{shapenum}={AnythingYouWant_}
@rem
@rem	where you can edit anything enclosed in curly braces {}. VGAFileName is the filename
@rem	of the VGA file (Faces, Paperdol or Shapes), shapenum is the shape number and
@rem	and the only restrictions to AnythingYouWant_ is that it must (a) not be blank and
@rem	(b) be unique. It is also essential that the AnythingYouWant_ be prefixes of the
@rem	corresponding png files in the \Data directory; compare the prefixes below with
@rem	the filenames of the files in the \Data directory if you are unsure what I mean.
@rem ============================================================================================

@set FacesPrefix0=Avatar_Female_Portrait_
@set FacesPrefix299=Avatar_Female_Portrait_Tatoo_
@set PaperdolPrefix4=Paperdoll_Female_Head_
@set ShapesPrefix400=Dead_Bodies_
@set ShapesPrefix1029=Avatar_Female_
@set ShapesPrefix1035=Avatar_Female_Nude_



@rem ============================================================================================
@rem	Create the Faces_Extract.ipk and Faces_Extract_Patch.ipk files
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following lines intact:
@rem
@rem		@echo     archive    ../<folder>/faces.vga>> Faces_Extract[_Patch].ipk
@rem		@echo     palette    ../static/palettes.flx>> Faces_Extract[_Patch].ipk
@rem
@rem	(bracketed items may not be there) The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %FacesPrefix{shapenum}%>> Faces_Extract[_Patch].ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %FacesPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "%varmodname%_Faces.ipk"
@rem	file found below (although "%varmodname%_Faces.ipk" can use more prefixes than
@rem	"Faces_Extract.ipk").
@rem ============================================================================================

@echo     archive    ../static/faces.vga>> Faces_Extract.ipk
@echo     palette    ../static/palettes.flx>> Faces_Extract.ipk
@echo     0/6:       %FacesPrefix0%>> Faces_Extract.ipk
@echo     299/6:     %FacesPrefix299%>> Faces_Extract.ipk

@echo     archive    ../patch/faces.vga>> Faces_Extract_Patch.ipk
@echo     palette    ../static/palettes.flx>> Faces_Extract_Patch.ipk
@echo     0/6:       %FacesPrefix0%>> Faces_Extract_Patch.ipk
@echo     299/6:     %FacesPrefix299%>> Faces_Extract_Patch.ipk



@rem ============================================================================================
@rem	Create the %varmodname%_Faces.ipk file
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following line intact:
@rem
@rem		@echo     archive    ../faces.vga>> %varmodname%_Faces.ipk
@rem
@rem	The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %FacesPrefix{shapenum}%>> %varmodname%_Faces.ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %FacesPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "Faces_Extract.ipk"
@rem	file found above (although "%varmodname%_Faces.ipk" can use more prefixes than
@rem	"Faces_Extract.ipk").
@rem ============================================================================================

@echo     archive    ../faces.vga>> %varmodname%_Faces.ipk
@echo     0/6:       %FacesPrefix0%>> %varmodname%_Faces.ipk
@echo     299/6:     %FacesPrefix299%>> %varmodname%_Faces.ipk



@rem ============================================================================================
@rem	Create the Fonts_Extract.ipk and Fonts_Extract_Patch.ipk files
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following lines intact:
@rem
@rem		@echo     archive    ../<folder>/fonts.vga>> Fonts_Extract[_Patch].ipk
@rem		@echo     palette    ../static/palettes.flx>> Fonts_Extract[_Patch].ipk
@rem
@rem	(bracketed items may not be there) The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %FontsPrefix{shapenum}%>> Fonts_Extract[_Patch].ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %FontsPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "%varmodname%_Fonts.ipk"
@rem	file found below (although "%varmodname%_Fonts.ipk" can use more prefixes than
@rem	"Fonts_Extract.ipk").
@rem ============================================================================================

@rem	This mod does not distribute any fonts, and does not need this file.



@rem ============================================================================================
@rem	Create the %varmodname%_Fonts.ipk file
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following line intact:
@rem
@rem		@echo     archive    ../fonts.vga>> %varmodname%_Fonts.ipk
@rem
@rem	The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %FontsPrefix{shapenum}%>> %varmodname%_Fonts.ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %FontsPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "Fonts_Extract.ipk"
@rem	file found above (although "%varmodname%_Fonts.ipk" can use more prefixes than
@rem	"Fonts_Extract.ipk").
@rem ============================================================================================

@rem	This mod does not distribute any fonts, and does not need this file.



@rem ============================================================================================
@rem	Create the Gumps_Extract.ipk and Gumps_Extract_Patch.ipk files
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following lines intact:
@rem
@rem		@echo     archive    ../<folder>/gumps.vga>> Gumps_Extract[_Patch].ipk
@rem		@echo     palette    ../static/palettes.flx>> Gumps_Extract[_Patch].ipk
@rem
@rem	(bracketed items may not be there) The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %GumpsPrefix{shapenum}%>> Gumps_Extract[_Patch].ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %GumpsPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "%varmodname%_Gumps.ipk"
@rem	file found below (although "%varmodname%_Gumps.ipk" can use more prefixes than
@rem	"Gumps_Extract.ipk").
@rem ============================================================================================

@rem	This mod does not distribute any gumps, and does not need this file.



@rem ============================================================================================
@rem	Create the %varmodname%_Gumps.ipk file
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following line intact:
@rem
@rem		@echo     archive    ../gumps.vga>> %varmodname%_Gumps.ipk
@rem
@rem	The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %GumpsPrefix{shapenum}%>> %varmodname%_Gumps.ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %GumpsPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "Gumps_Extract.ipk"
@rem	file found above (although "%varmodname%_Gumps.ipk" can use more prefixes than
@rem	"Gumps_Extract.ipk").
@rem ============================================================================================

@rem	This mod does not distribute any gumps, and does not need this file.



@rem ============================================================================================
@rem	Create the Paperdol_Extract.ipk and Paperdol_Extract_Patch.ipk files
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following line intact:
@rem
@rem		@echo     archive    ../<folder>/paperdol.vga>> Paperdol_Extract[_Patch].ipk
@rem		@echo     palette    ../static/palettes.flx>> Paperdol_Extract[_Patch].ipk
@rem
@rem	(bracketed items may not be there) The other lines may be edited as follows:
@rem
@rem	@echo {shapenum}/{framecount}:  %PaperdolPrefix{shapenum}%>> Paperdol_Extract[_Patch].ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %PaperdolPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "%varmodname%_Paperdol.ipk"
@rem	file found below (although "%varmodname%_Paperdol.ipk" can use more prefixes than
@rem	"Paperdol_Extract.ipk").
@rem ============================================================================================

@echo     archive    ../static/paperdol.vga>> Paperdol_Extract.ipk
@echo     palette    ../static/palettes.flx>> Paperdol_Extract.ipk
@echo     4/6:       %PaperdolPrefix4%>> Paperdol_Extract.ipk

@echo     archive    ../patch/paperdol.vga>> Paperdol_Extract_Patch.ipk
@echo     palette    ../static/palettes.flx>> Paperdol_Extract_Patch.ipk
@echo     4/6:       %PaperdolPrefix4%>> Paperdol_Extract_Patch.ipk



@rem ============================================================================================
@rem	Create the %varmodname%_Paperdol.ipk file
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following line intact:
@rem
@rem		@echo     archive    ../paperdol.vga>> %varmodname%_Paperdol.ipk
@rem
@rem	The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %PaperdolPrefix{shapenum}%>> %varmodname%_Paperdol.ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %PaperdolPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "Paperdol_Extract.ipk"
@rem	file found above (although "%varmodname%_Paperdol.ipk" can use more prefixes than
@rem	"Paperdol_Extract.ipk").
@rem ============================================================================================

@echo     archive    ../paperdol.vga>> %varmodname%_Paperdol.ipk
@echo     4/6:       %PaperdolPrefix4%>> %varmodname%_Paperdol.ipk



@rem ============================================================================================
@rem	Create the Shapes_Extract.ipk and Shapes_Extract_Patch.ipk files
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following line intact:
@rem
@rem		@echo     archive    ../<folder>shapes.vga>> Shapes_Extract[_Patch].ipk
@rem		@echo     palette    ../static/palettes.flx>> Shapes_Extract[_Patch].ipk
@rem
@rem	(bracketed items may not be there) The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %ShapePrefix{shapenum}%>> Shapes_Extract[_Patch].ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %ShapePrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "%varmodname%_Shapes.ipk"
@rem	file found below (although "%varmodname%_Shapes.ipk" can use more prefixes than
@rem	"Shapes_Extract.ipk").
@rem ============================================================================================

@echo     archive    ../static/shapes.vga>> Shapes_Extract.ipk
@echo     palette    ../static/palettes.flx>> Shapes_Extract.ipk
@echo     400/32:    %ShapesPrefix400%>> Shapes_Extract.ipk

@echo     archive    ../patch/shapes.vga>> Shapes_Extract_Patch.ipk
@echo     palette    ../static/palettes.flx>> Shapes_Extract_Patch.ipk
@echo     400/32:    %ShapesPrefix400%>> Shapes_Extract_Patch.ipk



@rem ============================================================================================
@rem	Create the %varmodname%_Shapes.ipk file
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following line intact:
@rem
@rem		@echo     archive    ../shapes.vga>> %varmodname%_Shapes.ipk
@rem
@rem	The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %ShapePrefix{shapenum}%>> %varmodname%_Shapes.ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %ShapePrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "Shapes_Extract.ipk"
@rem	file found above (although "%varmodname%_Shapes.ipk" can use more prefixes than
@rem	"Shapes_Extract.ipk").
@rem ============================================================================================

@echo     archive    ../shapes.vga>> %varmodname%_Shapes.ipk
@echo     400/32:    %ShapesPrefix400%>> %varmodname%_Shapes.ipk
@echo     1029/32:   %ShapesPrefix1029%>> %varmodname%_Shapes.ipk
@echo     1035/32:   %ShapesPrefix1035%>> %varmodname%_Shapes.ipk



@rem ============================================================================================
@rem	Create the Sprites_Extract.ipk and Sprites_Extract_Patch.ipk files
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following lines intact:
@rem
@rem		@echo     archive    ../<folder>/sprites.vga>> Sprites_Extract[_Patch].ipk
@rem		@echo     palette    ../static/palettes.flx>> Sprites_Extract[_Patch].ipk
@rem
@rem	(bracketed items may not be there) The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:  %SpritesPrefix{shapenum}%>> Sprites_Extract[_Patch].ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %SpritesPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "%varmodname%_Sprites.ipk"
@rem	file found below (although "%varmodname%_Sprites.ipk" can use more prefixes than
@rem	"Sprites_Extract.ipk").
@rem ============================================================================================

@rem	This mod does not distribute any sprites, and does not need this file.



@rem ============================================================================================
@rem	Create the %varmodname%_Sprites.ipk file
@rem
@rem	You can delete these lines if you want, the script will set the needed parameters.
@rem
@rem	If you want to edit these lines, you must keep the following line intact:
@rem
@rem		@echo     archive    ../sprites.vga>> %varmodname%_Sprites.ipk
@rem
@rem	The other lines may be edited as follows:
@rem
@rem	@echo   {shapenum}/{framecount}:   %SpritesPrefix{shapenum}%>> %varmodname%_Sprites.ipk
@rem
@rem	You can edit anything enclosed in curly braces {}. shapenum is the shape number and
@rem	framecount is the number of frames for the shape. The %SpritesPrefix{shapenum}% are
@rem	defined above, and must be the same as are used for the "Sprites_Extract.ipk"
@rem	file found above (although "%varmodname%_Sprites.ipk" can use more prefixes than
@rem	"Sprites_Extract.ipk").
@rem ============================================================================================

@rem	This mod does not distribute any sprites, and does not need this file.



@rem ============================================================================================
@rem
@rem	DO NOT EDIT ANYTHING BELOW THIS POINT!!!!!!
@rem
@rem ============================================================================================

@set ipackpath=..\..\tools\ipack.exe
@if not exist %ipackpath% goto ipackerror
@if not exist "..\static\shapes.vga" goto staticerror

@set varfaces=n
@set varfonts=n
@set vargumps=n
@set varpaperdol=n
@set varshapes=n
@set varsprites=n


@if not exist "Faces_Extract.ipk" goto copyfaces
@echo Extracting shapes from static\faces.vga...
@%ipackpath% -x Faces_Extract.ipk >> log.txt

:copyfaces
@if not exist "%varmodname%_Faces.ipk" goto xtractfonts
@set varfaces=c

@if not exist "..\patch\faces.vga" goto xtractfonts
@echo Found faces.vga in \Patch dir; using it as base...
@copy ..\patch\faces.vga faces.vga >> log.txt
@set varfaces=u

@if not exist "Faces_Extract_Patch.ipk" goto xtractfonts
@echo Extracting shapes from patch\faces.vga...
@%ipackpath% -x Faces_Extract_Patch.ipk >> log.txt


:xtractfonts
@if not exist "Fonts_Extract.ipk" goto copyfonts
@echo Extracting shapes from static\fonts.vga...
@%ipackpath% -x Fonts_Extract.ipk >> log.txt

:copyfonts
@if not exist "%varmodname%_Fonts.ipk" goto xtractgumps
@set varfonts=c

@if not exist "..\patch\fonts.vga" goto xtractgumps
@echo Found fonts.vga in \Patch dir; using it as base...
@copy ..\patch\fonts.vga fonts.vga >> log.txt
@set varfonts=u

@if not exist "Fonts_Extract_Patch.ipk" goto xtractgumps
@echo Extracting shapes from patch\fonts.vga...
@%ipackpath% -x Fonts_Extract_Patch.ipk >> log.txt


:xtractgumps
@if not exist "Gumps_Extract.ipk" goto copygumps
@echo Extracting shapes from static\gumps.vga...
@%ipackpath% -x Gumps_Extract.ipk >> log.txt

:copygumps
@if not exist "%varmodname%_Gumps.ipk" goto xtractpaperdol
@set vargumps=c

@if not exist "..\patch\gumps.vga" goto xtractpaperdol
@echo Found gumps.vga in \Patch dir; using it as base...
@copy ..\patch\gumps.vga gumps.vga >> log.txt
@set vargumps=u

@if not exist "Gumps_Extract_Patch.ipk" goto xtractpaperdol
@echo Extracting shapes from patch\gumps.vga...
@%ipackpath% -x Gumps_Extract_Patch.ipk >> log.txt


:xtractpaperdol
@if not exist "Paperdol_Extract.ipk" goto copypaperdol
@echo Extracting shapes from static\paperdol.vga...
@%ipackpath% -x Paperdol_Extract.ipk >> log.txt

:copypaperdol
@if not exist "%varmodname%_Paperdol.ipk" goto xtractshapes
@set varpaperdol=c

@if not exist "..\patch\paperdol.vga" goto xtractshapes
@echo Found paperdol.vga in \Patch dir; using it as base...
@copy ..\patch\paperdol.vga paperdol.vga >> log.txt
@set varpaperdol=u

@if not exist "Paperdol_Extract_Patch.ipk" goto xtractshapes
@echo Extracting shapes from patch\paperdol.vga...
@%ipackpath% -x Paperdol_Extract_Patch.ipk >> log.txt


:xtractshapes
@if not exist "Shapes_Extract.ipk" goto copyshapes
@echo Extracting shapes from static\shapes.vga...
@%ipackpath% -x Shapes_Extract.ipk >> log.txt

:copyshapes
@if not exist "%varmodname%_Shapes.ipk" goto xtractsprites
@set varshapes=c

@if not exist "..\patch\shapes.vga" goto xtractsprites
@echo Found shapes.vga in \Patch dir; using it as base...
@copy ..\patch\shapes.vga shapes.vga >> log.txt
@set varshapes=u

@if not exist "Shapes_Extract_Patch.ipk" goto xtractsprites
@echo Extracting shapes from patch\shapes.vga...
@%ipackpath% -x Shapes_Extract_Patch.ipk >> log.txt


:xtractsprites
@if not exist "Sprites_Extract.ipk" goto copysprites
@echo Extracting shapes from static\sprites.vga...
@%ipackpath% -x Sprites_Extract.ipk >> log.txt

:copysprites
@if not exist "%varmodname%_Sprites.ipk" goto pngcopy
@set varsprites=c

@if not exist "..\patch\sprites.vga" goto pngcopy
@echo Found sprites.vga in \Patch dir; using it as base...
@copy ..\patch\sprites.vga sprites.vga >> log.txt
@set varsprites=u

@if not exist "Sprites_Extract_Patch.ipk" goto pngcopy
@echo Extracting shapes from patch\sprites.vga...
@%ipackpath% -x Sprites_Extract_Patch.ipk >> log.txt


:pngcopy
@mkdir Temp >> log.txt
@echo Moving extracted png's to Temp dir...
@move *.png Temp\ >> log.txt

@echo Copying patch png's to Temp dir...
@copy /y Data\*.png Temp\ >> log.txt

@cd Temp

@if %varfaces%==n goto writefonts
@echo Writing faces.vga...
@..\%ipackpath% -%varfaces% ..\%varmodname%_Faces.ipk >> ..\log.txt

:writefonts
@if %varfonts%==n goto writegumps
@echo Writing fonts.vga...
@..\%ipackpath% -%varfonts% ..\%varmodname%_Fonts.ipk >> ..\log.txt

:writegumps
@if %varfonts%==n goto writepaperdol
@echo Writing gumps.vga...
@..\%ipackpath% -%vargumps% ..\%varmodname%_Gumps.ipk >> ..\log.txt

:writepaperdol
@if %varpaperdol%==n goto writeshapes
@echo Writing paperdol.vga...
@..\%ipackpath% -%varpaperdol% ..\%varmodname%_Paperdol.ipk >> ..\log.txt

:writeshapes
@if %varshapes%==n goto writesprites
@echo Writing shapes.vga...
@..\%ipackpath% -%varshapes% ..\%varmodname%_Shapes.ipk >> ..\log.txt

:writesprites
@if %varsprites%==n goto cleanup
@echo Writing sprites.vga...
@..\%ipackpath% -%varsprites% ..\%varmodname%_Sprites.ipk >> ..\log.txt

:cleanup
@echo Cleaning up temporary files...
@del *.* /q >> ..\log.txt
@cd..
@rmdir Temp >> log.txt

@echo Moving the *.vga files to the 'patch' folder...
@move *.vga ..\patch\ >> log.txt

@echo.
@echo.
@echo.
@echo The %varmodname% mod has been installed!
@echo.
@pause

@goto finalize

:staticerror
@echo.
@echo.
@echo.
@echo The STATIC dir of %vargametitle% was not found; you are executing the installation script
@echo from the wrong directory. See the readme.txt file for detailed instructions.
@echo.
@pause
@goto finalize

:ipackerror
@echo.
@echo.
@echo.
@echo IPack was not found. For this script to work, it MUST be in Exult\Tools directory.
@echo See the "readme.txt" file for more information.
@echo.
@pause
@goto finalize

:finalize
@del *.ipk /q>>log.txt
@del log.txt
